Index: palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4858)
+++ palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4860)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! further re-numbering of message IDs
+!
+! 4852 2021-01-25 07:18:30Z raasch
 ! re-numbering of message IDs
 !
@@ -1246,5 +1249,5 @@
     ELSEIF ( .NOT. ( call_chem_at_all_substeps ) )  THEN
        message_string = 'Sub-time-steps are skipped for chemistry time-steps'
-       CALL message( 'chem_check_parameters', 'PA0523', 0, 0, 0, 6, 0 )
+       CALL message( 'chem_check_parameters', 'PA0518', 0, 0, 0, 6, 0 )
     ENDIF
 !
@@ -1252,5 +1255,5 @@
     IF ( ( photolysis_scheme /= 'simple' ) .AND. ( photolysis_scheme /= 'constant' )  )  THEN
        message_string = 'Incorrect photolysis scheme selected, please check spelling'
-       CALL message( 'chem_check_parameters', 'PA0593', 1, 2, 0, 6, 0 )
+       CALL message( 'chem_check_parameters', 'PA0523', 1, 2, 0, 6, 0 )
     ENDIF
 !
@@ -1260,5 +1263,5 @@
        message_string =                                                                            &
        'Incorrect chemistry mechanism selected, check spelling in namelist and/or chem_gasphase_mod'
-       CALL message( 'chem_check_parameters', 'PA0675', 1, 2, 0, 6, 0 )
+       CALL message( 'chem_check_parameters', 'PA0551', 1, 2, 0, 6, 0 )
     ENDIF
 
@@ -1271,5 +1274,5 @@
     ELSE
        message_string = 'unknown boundary condition: bc_cs_b ="' // TRIM( bc_cs_b ) // '"'
-       CALL message( 'chem_check_parameters', 'PA0730', 1, 2, 0, 6, 0 )
+       CALL message( 'chem_check_parameters', 'PA0593', 1, 2, 0, 6, 0 )
     ENDIF
 !
@@ -1285,5 +1288,5 @@
     ELSE
        message_string = 'unknown boundary condition: bc_c_t ="' // TRIM( bc_cs_t ) // '"'
-       CALL message( 'chem_check_parameters', 'PA0731', 1, 2, 0, 6, 0 )
+       CALL message( 'chem_check_parameters', 'PA0675', 1, 2, 0, 6, 0 )
     ENDIF
 
@@ -1356,10 +1359,10 @@
          ( bc_cs_r == 'cyclic' .AND. bc_cs_l /= 'cyclic' ) )  THEN
        message_string = 'boundary conditions bc_cs_l and bc_cs_r must both be cyclic or non-cyclic'
-       CALL message( 'chem_check_parameters','PA0716', 1, 2, 0, 6, 0 )
+       CALL message( 'chem_check_parameters','PA0714', 1, 2, 0, 6, 0 )
     ENDIF
     IF ( ( bc_cs_n == 'cyclic' .AND. bc_cs_s /= 'cyclic' )  .OR.                                   &
          ( bc_cs_s == 'cyclic' .AND. bc_cs_n /= 'cyclic' ) )  THEN
        message_string = 'boundary conditions bc_cs_n and bc_cs_s must both be cyclic or non-cyclic'
-       CALL message( 'chem_check_parameters','PA0716', 1, 2, 0, 6, 0 )
+       CALL message( 'chem_check_parameters','PA0714', 1, 2, 0, 6, 0 )
     ENDIF
 !
@@ -1413,5 +1416,5 @@
           message_string = 'Unused/incorrect input for initial surface value: ' //     &
                             TRIM( cs_name(lsp_usr) )
-          CALL message( 'chem_check_parameters', 'PA0732', 1, 2, 0, 6, 0 )
+          CALL message( 'chem_check_parameters', 'PA0715', 1, 2, 0, 6, 0 )
        ENDIF
        lsp_usr = lsp_usr + 1
@@ -1432,5 +1435,5 @@
           message_string = 'Unused/incorrect input of chemical species for surface emission fluxes: '  &
                             // TRIM( surface_csflux_name(lsp_usr) )
-          CALL message( 'chem_check_parameters', 'PA0733', 1, 2, 0, 6, 0 )
+          CALL message( 'chem_check_parameters', 'PA0716', 1, 2, 0, 6, 0 )
        ENDIF
        lsp_usr = lsp_usr + 1
@@ -2348,5 +2351,5 @@
                 IF ( cs_heights(1,1) /= 0.0_wp )  THEN
                    message_string = 'The surface value of cs_heights must be 0.0'
-                   CALL message( 'chem_check_parameters', 'PA0734', 1, 2, 0, 6, 0 )
+                   CALL message( 'chem_check_parameters', 'PA0717', 1, 2, 0, 6, 0 )
                 ENDIF
 
@@ -2361,5 +2364,5 @@
                          IF ( npr_lev == 100 )  THEN
                             message_string = 'number of chem spcs exceeding the limit'
-                            CALL message( 'chem_check_parameters', 'PA0735', 1, 2, 0, 6, 0 )
+                            CALL message( 'chem_check_parameters', 'PA0730', 1, 2, 0, 6, 0 )
                             EXIT
                          ENDIF
@@ -2631,5 +2634,5 @@
                ( mode_emis /= 'PRE-PROCESSED'  ) )  THEN
              message_string = 'Incorrect mode_emiss  option select. Please check spelling'
-             CALL message( 'chem_parin', 'PA0736', 1, 2, 0, 6, 0 )
+             CALL message( 'chem_parin', 'PA0731', 1, 2, 0, 6, 0 )
           ENDIF
        ELSE
@@ -2638,5 +2641,5 @@
                ( emiss_lod /= 2 ) )  THEN
              message_string = 'Invalid value for emiss_lod (0, 1, or 2)'
-             CALL message( 'chem_parin', 'PA0737', 1, 2, 0, 6, 0 )
+             CALL message( 'chem_parin', 'PA0732', 1, 2, 0, 6, 0 )
           ENDIF
        ENDIF
@@ -2646,5 +2649,5 @@
 !    IF ( (mode_emis /= 'PARAMETERIZED')  .AND. ( mode_emis /= 'DEFAULT' ) .AND. ( mode_emis /= 'PRE-PROCESSED'  ) )  THEN
 !       message_string = 'Incorrect mode_emiss  option select. Please check spelling'
-!       CALL message( 'chem_parin', 'PA0736', 1, 2, 0, 6, 0 )
+!       CALL message( 'chem_parin', 'PA0731', 1, 2, 0, 6, 0 )
 !    ENDIF
 
@@ -2670,5 +2673,5 @@
                            'NOTE - mode_emis will be depreciated in future releases&'   //         &
                            'please use emiss_lod to define emission mode'
-          CALL message( 'chem_parin', 'PA0738', 0, 0, 0, 6, 0 )
+          CALL message( 'chem_parin', 'PA0733', 0, 0, 0, 6, 0 )
 
        ELSE ! if emiss_lod is not set
@@ -2686,5 +2689,5 @@
                            'NOTE - mode_emis will be depreciated in future releases&'   //         &
                            'please use emiss_lod to define emission mode'
-          CALL message( 'chem_parin', 'PA0739', 0, 0, 0, 6, 0 )
+          CALL message( 'chem_parin', 'PA0734', 0, 0, 0, 6, 0 )
        ENDIF
 
@@ -2705,5 +2708,5 @@
                            'All emissions data will be loaded '             //                     &
                            'prior to start of simulation'
-          CALL message( 'chem_parin', 'PA0740', 0, 0, 0, 6, 0 )
+          CALL message( 'chem_parin', 'PA0735', 0, 0, 0, 6, 0 )
 
        ELSE                                     !< if new read mode selected
@@ -2714,5 +2717,5 @@
                               'currently unavailable for LODs 0 and 1.&'   //                      &
                               'Reverting to legacy emission read mode'
-             CALL message( 'chem_parin', 'PA0741', 0, 0, 0, 6, 0 )
+             CALL message( 'chem_parin', 'PA0736', 0, 0, 0, 6, 0 )
 
              emiss_read_legacy_mode = .TRUE.
@@ -2723,5 +2726,5 @@
                               'LOD 2 emissions will be updated on-demand ' //                      &
                               'according to indicated timestamps'
-             CALL message( 'chem_parin', 'PA0742', 0, 0, 0, 6, 0 )
+             CALL message( 'chem_parin', 'PA0737', 0, 0, 0, 6, 0 )
 
           ENDIF
@@ -3876,5 +3879,5 @@
              message_string = 'No lsm-vegetation type defined. Please define vegetation type to' //&
                               ' enable deposition calculation'
-             CALL message( 'chem_depo', 'PA0743', 1, 2, 0, 6, 0 )
+             CALL message( 'chem_depo', 'PA0738', 1, 2, 0, 6, 0 )
           ELSEIF ( luv_palm == ind_luv_b_soil )  THEN
              luv_dep = 9
@@ -3921,5 +3924,5 @@
              message_string = 'No lsm-pavement type defined. Please define pavement type to ' //   &
                               'enable deposition calculation'
-             CALL message( 'chem_depo', 'PA0743', 1, 2, 0, 6, 0 )
+             CALL message( 'chem_depo', 'PA0738', 1, 2, 0, 6, 0 )
           ELSEIF ( lup_palm == ind_lup_asph_conc )  THEN
              lup_dep = 9
@@ -3960,5 +3963,5 @@
              message_string = 'No lsm-water type defined. Please define water type to enable' //   &
                               ' deposition calculation'
-             CALL message( 'chem_depo', 'PA0743', 1, 2, 0, 6, 0 )
+             CALL message( 'chem_depo', 'PA0738', 1, 2, 0, 6, 0 )
           ELSEIF ( luw_palm ==  ind_luw_lake )  THEN
              luw_dep = 13
@@ -4459,5 +4462,5 @@
              message_string = 'No usm-vegetation type defined. Please define vegetation type to' //&
                               ' enable deposition calculation'
-             CALL message( 'chem_depo', 'PA0743', 1, 2, 0, 6, 0 )
+             CALL message( 'chem_depo', 'PA0738', 1, 2, 0, 6, 0 )
           ELSEIF ( lug_palm == ind_luv_b_soil )  THEN
              lug_dep = 9
@@ -4507,5 +4510,5 @@
              message_string = 'No pavement type defined. Please define pavement type to enable' // &
                               ' deposition calculation'
-             CALL message( 'chem_depo', 'PA0745', 1, 2, 0, 6, 0 )
+             CALL message( 'chem_depo', 'PA0739', 1, 2, 0, 6, 0 )
           ELSEIF ( luu_palm == ind_lup_asph_conc )  THEN
              luu_dep = 9
@@ -4549,5 +4552,5 @@
              message_string = 'No usm-pavement type defined. Please define pavement type to ' //   &
                               'enable deposition calculation'
-             CALL message( 'chem_depo', 'PA0743', 1, 2, 0, 6, 0 )
+             CALL message( 'chem_depo', 'PA0738', 1, 2, 0, 6, 0 )
           ELSEIF ( lud_palm == ind_lup_asph_conc )  THEN
              lud_dep = 9
@@ -5306,5 +5309,5 @@
     CASE default
        message_string = 'Component '// TRIM( compnam ) // ' not supported'
-       CALL message( 'rc_special', 'PA0746', 1, 2, 0, 6, 0 )
+       CALL message( 'rc_special', 'PA0740', 1, 2, 0, 6, 0 )
     END SELECT
 
@@ -5359,5 +5362,5 @@
     CASE default
        message_string = 'Component '// TRIM( compnam ) // ' not supported'
-       CALL message( 'rc_gw', 'PA0746', 1, 2, 0, 6, 0 )
+       CALL message( 'rc_gw', 'PA0740', 1, 2, 0, 6, 0 )
     END SELECT
 
@@ -5572,5 +5575,5 @@
     CASE default
        message_string = 'Component '// TRIM( compnam ) // ' not supported'
-       CALL message( 'rc_gstom', 'PA0746', 1, 2, 0, 6, 0 )
+       CALL message( 'rc_gstom', 'PA0740', 1, 2, 0, 6, 0 )
     END SELECT
 
@@ -5928,5 +5931,5 @@
           ELSE
              message_string = 'nwet can only be 0 or 1'
-             CALL message( 'rc_gsoil_eff', 'PA0747', 1, 2, 0, 6, 0 )
+             CALL message( 'rc_gsoil_eff', 'PA0741', 1, 2, 0, 6, 0 )
           ENDIF
        ENDIF