Index: palm/trunk/SOURCE/lagrangian_particle_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4861)
+++ palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4865)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+! Remove unnecessary interface decalrations and public statments for private routines
+!
+! 4843 2021-01-15 15:22:11Z raasch
 ! local namelist parameter added to switch off the module although the respective module namelist
 ! appears in the namelist file
@@ -435,5 +438,4 @@
            lpm_header,                                                                             &
            lpm_init,                                                                               &
-           lpm_interaction_droplets_ptq,                                                           &
            lpm_init_arrays,                                                                        &
            lpm_last_actions,                                                                       &
@@ -441,5 +443,4 @@
            lpm_rrd_global,                                                                         &
            lpm_rrd_local,                                                                          &
-           lpm_rrd_local_particles,                                                                &
            lpm_wrd_global,                                                                         &
            lpm_wrd_local
@@ -495,76 +496,12 @@
     END INTERFACE lpm_wrd_global
 
-    INTERFACE lpm_advec
-       MODULE PROCEDURE lpm_advec
-    END INTERFACE lpm_advec
-
-    INTERFACE lpm_calc_liquid_water_content
-       MODULE PROCEDURE lpm_calc_liquid_water_content
-    END INTERFACE
-
-    INTERFACE lpm_interaction_droplets_ptq
-       MODULE PROCEDURE lpm_interaction_droplets_ptq
-       MODULE PROCEDURE lpm_interaction_droplets_ptq_ij
-    END INTERFACE lpm_interaction_droplets_ptq
-
-    INTERFACE lpm_boundary_conds
-       MODULE PROCEDURE lpm_boundary_conds
-    END INTERFACE lpm_boundary_conds
-
-    INTERFACE lpm_droplet_condensation
-       MODULE PROCEDURE lpm_droplet_condensation
-    END INTERFACE
-
-    INTERFACE lpm_droplet_collision
-       MODULE PROCEDURE lpm_droplet_collision
-    END INTERFACE lpm_droplet_collision
-
-    INTERFACE lpm_init_kernels
-       MODULE PROCEDURE lpm_init_kernels
-    END INTERFACE lpm_init_kernels
-
-    INTERFACE lpm_splitting
-       MODULE PROCEDURE lpm_splitting
-    END INTERFACE lpm_splitting
-
-    INTERFACE lpm_merging
-       MODULE PROCEDURE lpm_merging
-    END INTERFACE lpm_merging
-
-    INTERFACE lpm_exchange_horiz
-       MODULE PROCEDURE lpm_exchange_horiz
-    END INTERFACE lpm_exchange_horiz
-
     INTERFACE lpm_exchange_horiz_bounds
        MODULE PROCEDURE lpm_exchange_horiz_bounds
     END INTERFACE lpm_exchange_horiz_bounds
 
-    INTERFACE lpm_move_particle
-       MODULE PROCEDURE lpm_move_particle
-    END INTERFACE lpm_move_particle
-
-    INTERFACE realloc_particles_array
-       MODULE PROCEDURE realloc_particles_array
-    END INTERFACE realloc_particles_array
-
-    INTERFACE dealloc_particles_array
-       MODULE PROCEDURE dealloc_particles_array
-    END INTERFACE dealloc_particles_array
-
     INTERFACE lpm_last_actions
        MODULE PROCEDURE lpm_last_actions
     END INTERFACE lpm_last_actions
 
-    INTERFACE lpm_sort_and_delete
-       MODULE PROCEDURE lpm_sort_and_delete
-    END INTERFACE lpm_sort_and_delete
-
-    INTERFACE lpm_sort_timeloop_done
-       MODULE PROCEDURE lpm_sort_timeloop_done
-    END INTERFACE lpm_sort_timeloop_done
-
-    INTERFACE lpm_pack
-       MODULE PROCEDURE lpm_pack
-    END INTERFACE lpm_pack
 
  CONTAINS
@@ -5537,23 +5474,23 @@
 !> Call for grid point i,j
 !--------------------------------------------------------------------------------------------------!
- SUBROUTINE lpm_interaction_droplets_ptq_ij( i, j )
-
-    INTEGER(iwp) ::  i    !< running index x direction
-    INTEGER(iwp) ::  j    !< running index y direction
-    INTEGER(iwp) ::  k    !< running index z direction
-
-    REAL(wp) ::  flag     !< flag to mask topography grid points
-
-
-    DO  k = nzb+1, nzt
-!
-!--    Predetermine flag to mask topography
-       flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
-
-       q(k,j,i)  = q(k,j,i)  - ql_c(k,j,i) * flag
-       pt(k,j,i) = pt(k,j,i) + lv_d_cp * ql_c(k,j,i) * d_exner(k) * flag
-    ENDDO
-
- END SUBROUTINE lpm_interaction_droplets_ptq_ij
+!  SUBROUTINE lpm_interaction_droplets_ptq_ij( i, j )
+!
+!     INTEGER(iwp) ::  i    !< running index x direction
+!     INTEGER(iwp) ::  j    !< running index y direction
+!     INTEGER(iwp) ::  k    !< running index z direction
+!
+!     REAL(wp) ::  flag     !< flag to mask topography grid points
+!
+!
+!     DO  k = nzb+1, nzt
+! !
+! !--    Predetermine flag to mask topography
+!        flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
+!
+!        q(k,j,i)  = q(k,j,i)  - ql_c(k,j,i) * flag
+!        pt(k,j,i) = pt(k,j,i) + lv_d_cp * ql_c(k,j,i) * d_exner(k) * flag
+!     ENDDO
+!
+!  END SUBROUTINE lpm_interaction_droplets_ptq_ij
 
 