Index: /palm/trunk/SOURCE/chem_modules.f90
===================================================================
--- /palm/trunk/SOURCE/chem_modules.f90	(revision 4880)
+++ /palm/trunk/SOURCE/chem_modules.f90	(revision 4881)
@@ -21,9 +21,13 @@
 ! Current revisions:
 ! -----------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! removed unnecessarty namelist parameters
+!
+! 
+! 4828 2021-01-05 11:21:41Z Giersch
 ! Enable output of vertical fluxes of chemical species.
 ! 
@@ -224,14 +228,8 @@
     LOGICAL ::  bc_radiation_cs_s         = .FALSE.  !< flag for indicating a radiation/neumann
                                                      !< condition at the south boundary
-    LOGICAL ::  constant_top_csflux(99)   = .TRUE.   !< internal flag, set to .FALSE. if no
-                                                     !< top_csflux is prescribed
     LOGICAL ::  constant_csflux(99)       = .TRUE.   !< internal flag, set to .FALSE. if no
                                                      !< surface_csflux is prescribed
-    LOGICAL ::  call_chem_at_all_substeps = .FALSE.  !< namelist parameter: ....???
-    LOGICAL ::  chem_debug0               = .FALSE.  !< namelist parameter: flag for minimum print
-                                                     !< output
-    LOGICAL ::  chem_debug1               = .FALSE.  !< namelist parameter: flag for print output
-    LOGICAL ::  chem_debug2               = .FALSE.  !< namelist parameter: flag for further print
-                                                     !< output
+    LOGICAL ::  call_chem_at_all_substeps = .FALSE.  !< namelist parameter: Never set true 
+                                                     !< except for tests
     LOGICAL ::  chem_gasphase_on          = .TRUE.   !< namelist parameter: flag to switch off
                                                      !< chemical reactions
@@ -248,12 +246,11 @@
                                                      !< model
 
-    REAL(wp) ::  cs_surface_initial_change(99)     = 0.0_wp        !< namelist parameter: ...???
-    REAL(wp) ::  cs_vertical_gradient(99,10)       = 0.0_wp        !< namelist parameter: ...???
-    REAL(wp) ::  cs_vertical_gradient_level(99,10) = -999999.9_wp  !< namelist parameter: ...???
-    REAL(wp) ::  emiss_factor_main(99)             = -9999.0_wp    !< namelist parameter: ...???
-    REAL(wp) ::  emiss_factor_side(99)             = -9999.0_wp    !< namelist parameter: ...???
-    REAL(wp) ::  surface_csflux(99)                = 0.0_wp        !< namelist parameter: ...???
-    REAL(wp) ::  top_csflux(99)                    = 0.0_wp        !< namelist parameter: ...???
-    REAL(wp) ::  wall_csflux(99,0:5)               = 0.0_wp        !< namelist parameter: ...???
+    REAL(wp) ::  emiss_factor_main(99)             = -9999.0_wp  !< namelist parameter: weighting  factor
+                                                                 !< for LOD 0 parameterized emissions
+    REAL(wp) ::  emiss_factor_side(99)             = -9999.0_wp  !< namelist parameter: weighting  factor
+                                                                 !< for LOD 0 parameterized emissions
+    REAL(wp) ::  surface_csflux(99)                = 0.0_wp      !< namelist parameter: surface emission 
+                                                                 !< flux or LOD 0 parameterized emissions
+    REAL(wp) ::  wall_csflux(99,0:5)               = 0.0_wp      !< namelist parameter: ...???
 
     REAL(wp), DIMENSION(99)     ::  cs_surface = 0.0_wp        !< namelist parameter: chem species
Index: /palm/trunk/SOURCE/chem_photolysis_mod.f90
===================================================================
--- /palm/trunk/SOURCE/chem_photolysis_mod.f90	(revision 4880)
+++ /palm/trunk/SOURCE/chem_photolysis_mod.f90	(revision 4881)
@@ -20,9 +20,13 @@
 ! Current revisions:
 ! -----------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! removed chem_debug parameter
+! 
+! 
+! 4828 2021-01-05 11:21:41Z Giersch
 ! further re-formatting to follow the PALM coding standard
 !
@@ -78,7 +82,4 @@
     USE chem_modules,                                                                              &
         ONLY: phot_frequen, photolysis_scheme
-
-    USE chem_modules,                                                                              &
-        ONLY: chem_debug2
 
     USE kinds
Index: /palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4880)
+++ /palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4881)
@@ -26,4 +26,9 @@
 ! -----------------
 ! $Id$
+! removed unnecessarty namelist parameters and commented output statements
+! and cs_surface_initial_change
+!
+!
+! 4860 2021-02-01 08:10:59Z raasch
 ! further re-numbering of message IDs
 !
@@ -297,6 +302,4 @@
 ! ------------
 !> Chemistry model for PALM-4U
-!> @todo Extend chem_species type by nspec and nvar as addititional elements (RF)
-!> @todo Check possibility to reduce dimension of chem_species%conc from nspec to nvar (RF)
 !> @todo Adjust chem_rrd_local to CASE structure of others modules. It is not allowed to use the
 !>       chemistry model in a precursor run and additionally not using it in a main run
@@ -308,5 +311,4 @@
 !> @todo slight differences in passive scalar and chem spcs when chem reactions turned off. Need to
 !>       be fixed. bK
-!> @todo test nesting for chem spcs, was implemented by suehring (kanani)
 !> @todo chemistry error messages
 !
@@ -1521,8 +1523,4 @@
                   (variable(char_len-2:) == '_xz')  .OR.                                           &
                   (variable(char_len-2:) == '_yz') ) )  THEN
-!
-!--   todo: remove or replace by "CALL message" mechanism (kanani)
-!                    IF(myid == 0)  WRITE(6,*) 'Output of species ' // TRIM( variable )  //       &
-!                                                             TRIM( chem_species(lsp)%name )
              IF (av == 0)  THEN
                 DO  i = nxl, nxr
@@ -1638,8 +1636,4 @@
       DO  lsp = 1, nspec
          IF ( TRIM( spec_name ) == TRIM( chem_species(lsp)%name) )  THEN
-!
-!--   todo: remove or replace by "CALL message" mechanism (kanani)
-!              IF(myid == 0 .AND. chem_debug0 )  WRITE(6,*) 'Output of species ' // TRIM( variable )  // &
-!                                                           TRIM( chem_species(lsp)%name )
             IF (av == 0)  THEN
                DO  i = nxl, nxr
@@ -1717,8 +1711,4 @@
     DO  lsp=1,nspec
        IF (TRIM( spec_name ) == TRIM( chem_species(lsp)%name) )  THEN
-!
-!-- todo: remove or replace by "CALL message" mechanism (kanani)
-!              IF(myid == 0 .AND. chem_debug0 )  WRITE(6,*) 'Output of species ' // TRIM( variable )  // &
-!                                                        TRIM( chem_species(lsp)%name )
           IF (av == 0)  THEN
              IF ( .NOT. mask_surface(mid) )  THEN
@@ -2272,17 +2262,4 @@
        ENDIF
 !
-!--    If required, change the surface chem spcs at the start of the 3D run
-       IF ( cs_surface_initial_change(1) /= 0.0_wp )  THEN
-          DO  lsp = 1, nspec
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(nzb,j,i), 0 ) )
-                   chem_species(lsp)%conc(nzb,j,i) = chem_species(lsp)%conc(nzb,j,i) +             &
-                                                     cs_surface_initial_change(lsp) * flag
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-
     ENDIF
 !
@@ -2295,9 +2272,4 @@
     DO  lsp = 1, nphot
        phot_frequen(lsp)%name = phot_names(lsp)
-!
-!-- todo: remove or replace by "CALL message" mechanism (kanani)
-!--       IF( myid == 0 )  THEN
-!--          WRITE(6,'(a,i4,3x,a)')  'Photolysis: ',lsp,TRIM( phot_names(lsp) )
-!--       ENDIF
        phot_frequen(lsp)%freq(nzb:nzt+1,nysg:nyng,nxlg:nxrg)  =>  freq_1(:,:,:,lsp)
     ENDDO
@@ -2546,7 +2518,4 @@
          bc_cs_t,                                                                                  &
          call_chem_at_all_substeps,                                                                &
-         chem_debug0,                                                                              &
-         chem_debug1,                                                                              &
-         chem_debug2,                                                                              &
          chem_gasphase_on,                                                                         &
          chem_mechanism,                                                                           &
@@ -2555,6 +2524,4 @@
          cs_profile,                                                                               &
          cs_surface,                                                                               &
-         cs_surface_initial_change,                                                                &
-         cs_vertical_gradient_level,                                                               &
          daytype_mdh,                                                                              &
          deposition_dry,                                                                           &
@@ -2575,6 +2542,4 @@
          photolysis_scheme,                                                                        &
          wall_csflux,                                                                              &
-         cs_vertical_gradient,                                                                     &
-         top_csflux,                                                                               &
          surface_csflux,                                                                           &
          surface_csflux_name,                                                                      &
Index: /palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/surface_mod.f90	(revision 4880)
+++ /palm/trunk/SOURCE/surface_mod.f90	(revision 4881)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! removed constant_top_csflux option
+!
+!
+! 4877 2021-02-17 16:17:35Z suehring
 ! bugfix in init_single_surface_properties for vertical surfaces
 !
@@ -2928,11 +2932,4 @@
     IF ( passive_scalar .AND. constant_top_scalarflux )  surf%ssws(num_h) = top_scalarflux *       &
                                                                             rho_air_zw(nzt+1)
-!
-!-- Prescribe top chemical species' flux
-    DO  lsp = 1, nvar
-       IF ( air_chemistry  .AND.  constant_top_csflux(lsp) )  THEN
-          surf%cssws(lsp,num_h) = top_csflux(lsp) * rho_air_zw(nzt+1)
-       ENDIF
-    ENDDO
 !
 !-- Prescribe top salinity flux