Index: /palm/trunk/SOURCE/chem_emissions_mod.f90
===================================================================
--- /palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 4886)
+++ /palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 4887)
@@ -26,11 +26,14 @@
 ! -----------------
 ! $Id$
+! Unnecessary comments removed
+!
+! 4828 2021-01-05 11:21:41Z Giersch 
 ! Implementation of downward facing USM and LSM surfaces
-! 
+!
 ! 4559 2020-06-11 08:51:48Z raasch
 ! file re-formatted to follow the PALM coding standard
 !
 ! 4481 2020-03-31 18:55:54Z maronga
-! Implemented on-demand read mode for LOD 2 (ECC)
+! Implemented on-demand read mode for LOD 2 NB
 !  - added following module global variables
 !    - input_file_chem (namesake in netcdf_data_input_mod is local)
@@ -126,11 +129,4 @@
 !>  MODULE for reading-in Chemistry Emissions data
 !>
-!> @todo Rename nspec to n_emis to avoid inteferece with nspec from chem_gasphase_mod
-!> @todo Check_parameters routine should be developed: for now it includes just one condition
-!> @todo Use of Restart files not contempled at the moment
-!> @todo revise indices of files read from the netcdf: preproc_emission_data and expert_emission_data
-!> @todo for now emission data may be passed on a singular vertical level: need to be more flexible
-!> @todo fill/activate restart option in chem_emissions_init
-!> @todo discuss dt_emis
 !> @note <Enter notes on the module>
 !> @bug  <Enter known bugs here>
@@ -169,5 +165,5 @@
 
 !
-!-- 20200203 (ECC)
+!-- 20200203 NB
 !-- Added new palm_date_time_mod for on-demand emission reading
 
@@ -181,9 +177,5 @@
 
 !
-!-- 20200203 (ECC) - variable unused
-!    CHARACTER (LEN=80) ::  filename_emis           !< Variable for the name of the netcdf input file
-
-!
-!-- 20200203 (ECC) new variables for on-demand read mode
+!-- 20200203 NB new variables for on-demand read mode
 
     CHARACTER(LEN=*),   PARAMETER   :: input_file_chem = 'PIDS_CHEM' !< chemistry file
@@ -210,9 +202,4 @@
     SAVE
 
-! !
-! !-- Checks Input parameters
-!     INTERFACE chem_emissions_check_parameters
-!        MODULE PROCEDURE chem_emissions_check_parameters
-!     END INTERFACE chem_emissions_check_parameters
 !
 !-- Matching Emissions actions
@@ -232,5 +219,5 @@
 
 !
-!-- 20200203 (ECC) new interfaces for on-demand mode
+!-- 20200203 NB new interfaces for on-demand mode
 
 !
@@ -246,7 +233,5 @@
 
 !
-!-- 20200203 (ECC) update public routines
-
-!    PUBLIC chem_emissions_init, chem_emissions_match, chem_emissions_setup
+!-- 20200203 NB update public routines
 
     PUBLIC chem_emissions_init, chem_emissions_match, chem_emissions_setup,                        &
@@ -257,30 +242,4 @@
 
  CONTAINS
-
-! !------------------------------------------------------------------------------------------------!
-! ! Description:
-! ! ------------
-! !> Routine for checking input parameters
-! !------------------------------------------------------------------------------------------------!
-!  SUBROUTINE chem_emissions_check_parameters
-!
-!     IMPLICIT NONE
-!
-!     TYPE(chem_emis_att_type) ::  emt
-!
-! !
-! !-- Check if species count matches the number of names
-! !-- passed for the chemiscal species
-!
-!     IF  ( SIZE(emt%species_name) /= emt%n_emiss_species  )  THEN
-! !    IF  ( SIZE(emt%species_name) /= emt%nspec  )  THEN
-!
-!        message_string = 'Numbers of input emission species names and number of species'     //      &
-!                          'for which emission values are given do not match'
-!        CALL message( 'chem_emissions_check_parameters', 'CM0437', 2, 2, 0, 6, 0 )
-!
-!     ENDIF
-!
-!  END SUBROUTINE chem_emissions_check_parameters
 
 
@@ -794,16 +753,4 @@
 
     INTEGER(iwp) :: ispec                        !< running index
-
-!
-!-- Actions for initial runs
-!  IF  (  TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
-!--    ...
-!
-!
-!-- Actions for restart runs
-!  ELSE
-!--    ...
-!
-!  ENDIF
 
 
@@ -1093,26 +1040,12 @@
                                              hyp(nzb:nzt+1)                            ! Pa
 
-! (ecc) for reference
-!                   m**3/Nmole               (J/mol)*K^-1           K                      Pa
-!             conv_to_ratio(nzb:nzt+1,j,i) = ( (Rgas * tmp_temp(nzb:nzt+1,j,i)) / ((hyp(nzb:nzt+1))) )
-
           ENDDO
        ENDDO
 
 
-! (ecc) moved initialization immediately after allocation
-!
-!-- Initialize
-
-!       emis_distribution(:,nys:nyn,nxl:nxr,:) = 0.0_wp
-
-
 !
 !-- LOD 2 (PRE-PROCESSED MODE)
 
        IF  ( emiss_lod == 2 )  THEN
-
-! for reference (ecc)
-!       IF  ( TRIM( mode_emis ) == "PRE-PROCESSED" )  THEN
 
 !
@@ -1130,7 +1063,4 @@
 !--     LOD 1 (DEFAULT MODE)
         ELSEIF  ( emiss_lod == 1 )  THEN
-
-! for reference (ecc)
-!       ELSEIF  ( TRIM( mode_emis ) == "DEFAULT" )  THEN
 
 !
@@ -1232,7 +1162,4 @@
 
 
-! for reference (ecc)
-!       ELSEIF  ( TRIM( mode_emis ) == "PARAMETERIZED" )  THEN
-
 !
 !--       Assign constant values of time factors, diurnal profile for traffic sector
@@ -1257,10 +1184,5 @@
 !--  Emission distribution calculation
 
-!
-!--    LOD 0 (PARAMETERIZED mode)
        IF  ( emiss_lod == 0 )  THEN
-
-! for reference (ecc)
-!       IF  ( TRIM( mode_emis ) == "PARAMETERIZED" )  THEN
 
           DO  ispec = 1, n_matched_vars
@@ -1277,7 +1199,4 @@
 !--    LOD 1 (DEFAULT mode)
        ELSEIF  ( emiss_lod == 1 )  THEN
-
-! for referene (ecc)
-!       ELSEIF  ( TRIM( mode_emis ) == "DEFAULT" )  THEN
 
 !
@@ -1448,7 +1367,4 @@
        ELSEIF  ( emiss_lod == 2 )  THEN
 
-! for reference (ecc)
-!       ELSEIF  ( TRIM( mode_emis ) == "PRE-PROCESSED" )  THEN
-
 !
 !--       Cycle over species: n_matched_vars represents the number of species in common between the
@@ -1461,9 +1377,4 @@
                                        * conversion_factor
 
-
-!             emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                                &
-!                       emt(match_spec_input(ispec))%                                     &
-!                           preproc_emission_data(index_hh,1,:,:) *   &
-!                       conversion_factor
           ENDDO
 
@@ -1479,6 +1390,4 @@
 !--    Units of inputs are micromoles/m2/s
        IF  ( emiss_lod == 0 )  THEN
-! for reference (ecc)
-!       IF  ( TRIM( mode_emis ) == "PARAMETERIZED" )  THEN
 
           IF  (street_type_f%from_file)  THEN
@@ -1577,11 +1486,4 @@
                    ENDDO  ! ispec
 
-!
-!-- If no street type is defined, then assign zero emission to all the species
-! (ecc) moved to front (for reference)
-!                ELSE
-!
-!                   surf_lsm_h(0)%cssws(:,m) = 0.0_wp
-
                 ENDIF  ! street type
 
@@ -1775,5 +1677,5 @@
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !!
-!! 20200203 (ECC) - ON DEMAND EMISSION UPDATE MODE
+!! 20200203 NB - ON DEMAND EMISSION UPDATE MODE
 !!
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -1793,5 +1695,5 @@
 
 !
-!-- 20200203 (ECC)
+!-- 20200203 NB
 !
 !--------------------------------------------------------------------------------------------------!
@@ -1819,5 +1721,5 @@
 
 !
-!-- 20200203 (ECC)
+!-- 20200203 NB
 !
 !--------------------------------------------------------------------------------------------------!
@@ -1850,5 +1752,5 @@
 
 !
-!-- 20200203 (ECC)
+!-- 20200203 NB
 !
 !--------------------------------------------------------------------------------------------------!
@@ -1910,5 +1812,5 @@
 
 !
-!-- 20200203 (ECC)
+!-- 20200203 NB
 !
 !--------------------------------------------------------------------------------------------------!
@@ -2092,5 +1994,5 @@
 
 !
-!-- 20200203 (ECC)
+!-- 20200203 NB
 !
 !--------------------------------------------------------------------------------------------------!
@@ -2119,5 +2021,5 @@
                         chem_emis_att%n_emiss_species )
 !
-!-  Backward compatibility for salsa_mod (ECC)
+!-  Backward compatibility for salsa_mod NB
     chem_emis_att%nspec = chem_emis_att%n_emiss_species
 !
@@ -2160,5 +2062,5 @@
 
 !
-!-- 20200203 (ECC)
+!-- 20200203 NB
 !
 !--------------------------------------------------------------------------------------------------!
@@ -2214,5 +2116,5 @@
 
 !
-!-- 20200203 (ECC)
+!-- 20200203 NB
 !
 !--------------------------------------------------------------------------------------------------!
@@ -2312,5 +2214,5 @@
 
 !
-!-- 20200203 (ECC)
+!-- 20200203 NB
 !
 !--------------------------------------------------------------------------------------------------!
@@ -2395,5 +2297,5 @@
 
 !
-!-- 20200203 (ECC)
+!-- 20200203 NB
 !
 !--------------------------------------------------------------------------------------------------!
@@ -2421,5 +2323,5 @@
 
 !
-!-- 20200203 (ECC)
+!-- 20200203 NB
 !
 !--------------------------------------------------------------------------------------------------!
@@ -2458,5 +2360,5 @@
 
 !
-!-- 20200203 (ECC)
+!-- 20200203 NB
 !
 !--------------------------------------------------------------------------------------------------!
Index: /palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4886)
+++ /palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4887)
@@ -26,7 +26,9 @@
 ! -----------------
 ! $Id$
+! Unnecessary comments removed
+!
+! 4881 2021-02-19 22:05:08Z forkel
 ! removed unnecessarty namelist parameters and commented output statements
 ! and cs_surface_initial_change
-!
 !
 ! 4860 2021-02-01 08:10:59Z raasch
@@ -1972,6 +1974,5 @@
 
 !
-!-- 20200203 (ECC)
-!-- introduced additional interfaces for on-demand emission update
+!-- NB introduced additional interfaces for on-demand emission update
 
 !    USE chem_emissions_mod,                                                                        &
@@ -1998,6 +1999,5 @@
 
 !
-!-- 20200203 (ECC)
-!-- Calls specific emisisons initialization subroutines for legacy mode and on-demand mode
+!-- NB Calls specific emisisons initialization subroutines for legacy mode and on-demand mode
 
 !    IF ( emissions_anthropogenic )  CALL chem_emissions_init
@@ -2057,6 +2057,5 @@
     REAL(wp)     ::  flag              !< flag for masking topography/building grid points
 !
-!-- 20200203 ECC
-!-- reads netcdf data only under legacy mode
+!-- NB reads netcdf data only under legacy mode
 
 !    IF ( emissions_anthropogenic )  THEN
@@ -2658,10 +2657,10 @@
 
 !
-!-- (ECC) input check for emission read mode.
+!-- NB input check for emission read mode.
 !--    legacy : business as usual (everything read / set up at start of run)
 !--    new    : emission based on timestamp, and for lod2 data is loaded on an hourly basis
 
 !
-!-- (ECC) handler for emiss_read_legacy_mode
+!-- NB handler for emiss_read_legacy_mode
 !-- * emiss_read_legacy_mode is defaulted to TRUE
 !-- * if emiss_read_legacy_mode is TRUE and LOD is 0 or 1,